Finding out about Business Notification

Business Notification makes it possible to automatically notify employees as well as business partners about changes within Navision. For example, if a BOM (Bill of Materials) is changed by a product designer, other departments need to be aware of the changes: purchasing needs to adjust to the new or changed components; sales may need to inform customers about delays; and so on. Without an automatic process, this important information is easily lost.

The topic Getting Started in 3 Minutes shows how you can quickly start using Navision and Business Notification together. In How Does It Work? there is a more in-depth description of exactly how Navision and Business Notification work together, and Designing and Using Notifications introduces what needs to be set up in the Business Notification tools. Reading these topics will provide you with enough information to get started. The chapter called Concepts contains an explanation of each of the key concepts that are used in Business Notification. It is meant to be used as an easy reference to specific concepts, but it is also arranged so that it can be read from beginning to end.

The reference guides for the Notification Manager and for the Notification Designer are meant to be used as guides when you start working with the tools themselves. Both guides contain references to the user interface, as well as more topical guides for using the tools. The chapter called Creating Events in Navision outlines what needs to be done in Navision (by a C/AL developer) in order to create new solutions, while the topic, Templates Description, briefly describes the six pre-defined solutions that come with Business Notification.


Getting Started in 3 Minutes

The easiest way to get started is by using a template. A template contains everything that is needed, but it still needs some minor changes that are specific to how your company operates.

To start using a template:

  1. Create a copy of the template you want to use in the Business Notification Manager (the template itself is write-protected) by clicking New from template. The copy of the template is opened for editing in the Business Notification Designer.

  2. In the scheme, you can review and change the filters, the e-mail message, and so on.

  3. If you do nothing else, you must give at least one user permission to subscribe to the notification.

  4. When you have finished, save the scheme.

  5. To complete the scheme, click Complete. This will move the scheme to the list of completed schemes.

  6. To start the scheme, select the scheme and click Start.

The user that you have given subscription permission to can now subscribe to this notification.

From within Navision, when you have at least one subscriber, you can cause a notification to happen . Once you have done this, the subscriber should receive an e-mail message. For a more detailed description about how to cause a notification to happen and about templates, click here.

The following topics provide more information about how Business Notification works:


How Does It Work?

How does Navision and Business Notification know what to notify users about and when to do it? The answer to this is that something needs to happen in Navision and something needs to happen in Business Notification.

Navision supports Business Notification by providing business entities and events. (For a more detailed explanation of how Navision supports Business Notification, click here.) A business entity is, for example, a sales order or a bill of materials (BOM). Each business entity has one or more events attached. Events for a sales order could be "Order amount more than 10,000" or "Customer credit limit exceeded." For a BOM, events could be "BOM changed" or "BOM status changed."

When something happens in Navision that causes an event (for example, a sales order is saved that has an order amount larger than 10,000), a document is sent to Business Notification. This document contains data from the business entity. For the "Order amount more than 10,000" event for a sales order this data would probably include the identification of the sales order as well as the order amount.

Business Notification will read the document and all users that have subscribed to this event on this business entity will receive a notification in the form of an e-mail message. The data in the document can be merged into the e-mail message, so the notification does not just tell the recipient that something has happened: it can inform the recipient of the e-mail message exactly what has happened.

The Components

The installation guide on the distribution CD describes what and how to install Business Notification. In brief, Business Notification consists of two major components:

  1. The client-side Business Notification Manager (which includes the Business Notification Designer). The Business Notification Manager is installed by the Navision installer. The client-side component can be installed on multiple machines. The Navision client must be running locally before the Business Notification Manager is started.

  2. The server-side Business Notification component is installed separately. This component runs as a service and will be set to start automatically when the operating system starts. Normally, there is only one instance of this component running, just like you normally only have one instance of the Navision database server running.

The diagram below illustrates the components:

On each client, the following are needed:

  • A Navision 4.0 client that connects to the Navision database server

  • The Business Notification client (the Manager and the Designer)

  • Microsoft Internet Explorer 6.0

On the server side, the following is needed:

  • A Navision database server

  • A Business Notification server

  • A SQL Server

  • An SMTP server, or a relay to one

  • An Internet Information Server

The four machines shown in the diagram should be thought of as virtual servers in the sense that they do not need different, physical machines. All server-side components can run on one machine, or they can run on several machines, depending on the pre-existing setup, specific deployment requirements and so on.


Designing and Using Notifications

Notifications are sent to internal users that have actively subscribed to them, or to external recipients, such as business partners. When an internal user goes into the browser-based subscription tool, they see a list of notifications available for subscription. They can also use this tool to cancel subscriptions. External recipients are added when designing a scheme.

Designing

The list of notifications are created in the Business Notification Designer.

The following explains the key concepts in the Designer:

  • A notification is what a user subscribes to in order to receive e-mail messages.

  • A scheme is the set of rules that create a notification in Business Notification.

  • A filter is part of a scheme. It makes it possible for the program to decide whether to send a message, based on the data in the document received from Navision.

  • A template is a predefined notification solution, containing both the Navision part (business entity and event) and the scheme.

This list of notifications available for subscription is created on the basis of all the business entities and events that have been set up in Navision. To learn about adding new business entities and events in Navision click here. However, note that you can not do this in the Business Notification tools, and that it requires a Navision developer license.

As part of the setup of Business Notification, a power user will define the notifications. A notification is created by:

  1. Selecting a business entity. For example, "Bill of Materials."

  2. Selecting an event from this business entity. For example, "BOM Changed."

  3. Setting a filter on the notification. For example, "only notify if the change is to certain important parts, such as the wheels of a bicycle."

  4. Creating the e-mail message the subscribers will receive.

  5. Defining the users, or the groups of users, who are allowed to subscribe to the notification.

  6. Giving the notification a descriptive name. For example, "Bicycle Wheels Changed."

  7. Publishing the notification.

Using

For an end-user, there is little to do in order to use Business Notification. The end-user has to subscribe (sign up) for notifications that they have permission to subscribe to and that they are interested in and eventually they may want to cancel a previous subscription.

Once they have subscribed they will receive e-mail messages when the notification is triggered (when something happens in Navision that causes an event to be raised.)

For some solutions, there may be procedures to perform in Navision before events are raised and notifications are triggered. This is part of the functionality of the Navision part of the solution (the Navision business logic) and will be documented there.


Business Entity

A business entity is a representation of a real-world object. In an ERP system, relevant business entities could be, among many others, "Customer," "Sales Order" or "Invoice."

A business entity (or, to be specific, an instance of a business entity) contains data fields (such as "John Smith," the name of a customer) and metadata that describes the data fields (for example, the name of the data field, such as "Customer Name," and the type of the data field, such as "Text").

In the integration between Business Notification and Navision, a business entity has one more feature: an event. For example, a "Customer" business entity could have these events: "Customer Blocked" and "Customer Credit Limit Changed." When one of these events is raised in Navision, that is when "something happens," such as a customer being blocked or a credit limit being changed, a document, containing both the name of the event ("Customer Blocked") and the "Customer" business entity, is sent to Business Notification.


Event

The best way to understand events is to see an event as the mechanism that connects Navision and Business Notification. An event is tied to a business entity, and every notification is based on one event from one business entity. An event is raised in the Navision business logic (the C/AL code), as decided by a Navision developer, when "something" happens.

For example:

  • You want notifications when a customer is being blocked.

  • The developer creates a business entity (say, "Customer").

  • The developer adds an event (say, "Customer Blocked") to this business entity.

  • The developer tests if the blocked status of a customer in Navision has changed from not blocked to one of the blocked states (either "Ship," "Invoice" or "All") whenever the customer table is updated.

  • If the Blocked status has changed, the "Customer Blocked" event of the "Customer" business entity is raised.

  • This causes a document to be sent to Business Notification. This document contains the name of the event, as well as the data for the customer that is included in the "Customer" business entity.

  • Business Notification will now process the information in the document. Depending on the filters set up in Business Notification, one or more e-mail messages may be sent.


External Recipient

Internal users use subscription to sign up for notifications themselves, but if you want to send notifications to external recipients (for example, business partners) it is not possible for them to use subscription in the same way. This is because they do not (normally, at least) have access to your Intranet, nor are they registered as Windows users in your company.

Therefore, external recipients must be explicitly added in the Notification Designer. This does mean that you hard code names of these recipients into the schemes. To send notifications to the relevant business partner when Navision has raised an event, the e-mail address to send the notification to must be part of the data that Navision sends (the business entity). For a customer, for example, there is a standard field in the Navision Customer table for this called "E-Mail."


Filter

When an event is raised in Navision, Business Notification receives a document that contains the corresponding business entity. It is now possible to use a filter in Business Notification to decide whether a notification should be sent. For example:

For the business entity "Customer," there is an event called "Customer Blocked." The event is raised when the Blocked status of a customer is changed from not blocked to one of the blocked states (Ship, Invoice, or All). However, you only want notifications if the new status is "Ship." You can use a filter in Business Notification to achieve this.

You can base more than one notification on the same event. Continuing the (very simple) example from above, you could create three different notifications, by using two distinct filters: one that filters on the Blocked field having the value "Ship," one that filters on the Blocked field having the value "Invoice," and finally one that filters on the Blocked field having the value "All."

Important: a filter in Business Notification does not in any way query or re-query Navision: Navision sends a document, containing the data that the developer of the business entity in Navision has selected. A filter in Business Notification can only be used to further "refine" this data: it cannot extend or change the data sent from Navision.

This means that you cannot create a "time-calculation" filter in Business Notification, that is: you cannot create a filter that would evaluate an expression such as "today plus 7 days". Dates that you get from Navision are already "finalized", and the only filtering you can do is to evaluate against the exact date you get from Navision (such as: "if Order Date is after December 24th, 2004".)

These topics have more information: The Filter Form and More About Filters.


Notification

Notification is the core concept of Business Notification. Broadly speaking, a notification consists of:

  • Some business logic in Navision

  • A "document" that Navision sends to Business Notification

  • Some business logic in Business Notification

  • An e-mail message

The Navision business logic: the starting point for notification is the Navision business logic (the program code that makes Navision work). A Navision developer creates a test that will send a "document" to Business Notification when some predefined condition is fulfilled. This is called "raising an event." An example would be a test of whether the total amount of a sales orders is above a certain figure. If it is, the event is raised.

A "document" is sent to Business Notification: When the event is raised, Navision automatically sends a "document" to Business Notification. This "document" contains information about the event, as well as data that the Navision developer has decided is useful to have access to in Business Notification.

Business logic in Business Notification: when Business Notification receives a document from Navision, it will use its own, internal business logic to see if a notification e-mail should be sent, and to whom it should be sent. This business logic, or "rules," are setup in the Business Notification Designer.

The conclusion is that a notification e-mail message is sent when:

  1. The Navision business logic raises an event.

  2. Business Notification has a (started) scheme that responds to this event.

  3. For this specific event, and with the data in this actual instance, a notification has been set up to be sent.

  4. And there is at least one internal user subscribed to the scheme, or at least one external recipient has been set up.

It is true, though, that once the system is running, and from the viewpoint of the end-user, the actual e-mail message can, in many ways, be seen as the notification itself, and will often simply be referred to as such.


Scheme

A scheme is the name for the "rules" that Business Notification uses to decide when and how to send notifications. A scheme is created in the Business Notification Designer, and schemes are managed in the Business Notification Manager.

Information about the following is stored in a scheme:

  • A name for the scheme

  • The business entity and event that will activate it

  • Filters that are applied to business entities that are received

  • The text of the e-mail message that is sent to notify users

  • Permissions that describe which users can subscribe to the notification

  • A title and a description of the notification, used in the browser-based end-user subscription interface

  • Information about external recipients

A scheme can be "under construction," meaning that it is being developed, or changed. When it is ready for use, it is "completed." A completed scheme can be Started, or Stopped. As long as it is started, users can subscribe to it and will receive notifications when appropriate.


Subscription

Internal users, that is, users in your own company that have access to your Intranet, are not sent notification e-mail messages automatically. The have to actively subscribe to a notification in order to receive notifications. It is very important to note that:

  • When designing a notification in the Notification Designer, you give users or groups of users permission to subscribe to ( or sign up for) notifications.

  • The users themselves will have to use the browser-based subscription management application to subscribe to notifications (and also to delete subscriptions).

  • Users are not automatically informed of new notifications they have permission to subscribe to. If you need to distribute such information, you must do it yourself.

Notifications can also be sent to external recipients, such as business partners. These recipients are, contrary to the internal ones, set up explicitly.

The topic How to Subscribe describes the subscription interface and what end-users need to know about it.


Template

A template is a complete notification solution that is almost ready to use. It consists of:

  • The Navision object, or objects, that define business entities and events, and the business logic that raises the events.

  • One or more schemes in Business Notification that are activated by the event, or events, in Navision.

When working in the Notification Manager or in the Notification Designer, it is almost as if a scheme and a template are the same thing. There are some important differences though:

  • The scheme of a template is based on a specific business entity and event, and on a specific condition in the Navision business logic that raises the event.

  • The scheme of a template is read-only: when you have imported a template, you can create a new scheme based on the scheme in the template, but you cannot change the template itself.

When Business Notification is installed there are already a number of templates available. Both the Business Notification part (the schemes) and the Navision part (the Navision objects) are already installed and can be used.

This topic explains how to add additional templates to Business Notification, and how to remove templates from Business Notification, if and when you buy additional solutions. The procedure for installing the Navision part of a template will depend upon how the developer has designed this part of the solution. The specific instructions for installing the Navision objects will be part of the documentation for the solution.

Using a template

Before using (the copy of) a template, you must consider the following tasks in the Notification Designer:

  1. You must set permissions (this task is not optional).

  2. You should change the name from the default to something meaningful to you.

  3. You should consider if you need to use a filter - the Navision part may well be quite "generic," so you may want to limit the number of situations where notifications are actually sent.

  4. You must decide if you need to change the e-mail message, if the template contains one; if not, then you must create a message.

  5. You must enter a title and a description that make sense to your users (if, for example, you have used a filter, you may want to make a title and description that clearly describes to prospective subscribers the notifications they can expect to receive).


The Navision Side

Inside Navision, a developer can define the conditions that should raise events.

This is done by creating a business entity. A business entity is a document that represents some Navision data. While most data in Navision that represents real-world objects, such a sales order or a Bill of Materials (BOM), is stored internally in several tables, a business entity ties everything together in one object that more closely represents what the object looks like in the real world.

This document is created as an XMLport in Navision. For example, a BOM business entity would include fields that identify the BOM, as well as fields that describe the change to the BOM.

Furthermore, the developer adds an event to the XMLport. An event on an XMLport is like a function, but without a function body. When it is called (and it is called just like a regular function) the XMLport is serialized and sent to Business Notification.

An event belongs to one business entity. For example, for a business entity called "BOM," there can be an event called "BOM changed." In fact, one business entity can have several events attached. The BOM could also have an event called "BOM made inactive." These events would, of course, be raised in different situations.

When an event has been added, the developer can decide which conditions in the Navision business logic should raise the event. In the case of the BOM change, the developer would test a BOM against the previous version whenever it is saved. If one or more fields that are important have changed, he would create an instance of the XMLport, and make the C/AL call that raises the event. This will cause a document to be sent to Business Notification.


Notification Manager Overview

The Notification Manager is used for installing new schemes, starting installed schemes, importing templates, and so on.

The Notification Manager is started from the Start menu: All Programs, Microsoft Business Solutions-Navision, Business Notification Manager.

Note
The Navision client must be started before you start the Notification Manager and a database and a company must have been selected in Navision.

Most of the work is done in the Notification Manager main form. There is a separate form for template administration.


Notification Manager Main Form

The main form of the Notification Manager has two lists of schemes:

  1. The list in the upper part of the window: Schemes for construction

  2. The list in the lower part of the window: Completed schemes

A scheme in the Schemes for construction list has been installed, but is not currently active: you cannot subscribe to it, nor will notifications be sent from it. It can, however, be modified.

A scheme in the Completed schemes list is ready to use. If it has also been started (status is "Started"), it accepts subscriptions and notifications are sent. A scheme in this list, started or not, cannot be modified.

You can move a scheme from the Schemes for construction list to the Completed schemes list by selecting it and clicking Complete.

You can copy a scheme from the Completed schemes list to the Schemes for construction list by selecting it and clicking Copy for construction.

You can quickly access a specific area within this topic by using these links:

Schemes for construction
Completed schemes
Menu items
Buttons
Shortcut menus

To open the topic about the Template Administration tool click here.

Schemes for construction

The schemes in this list have been installed or created (for example, by clicking File, New; or by clicking File, New from template). An installed scheme is available in the Notification Manager, but it is not active. When a scheme is in this state, it can be opened for modification in the Notification Designer. A scheme can be moved from this list to the Completed schemes list by selecting it, and then clicking Complete scheme.

For each scheme in the list, the following information is displayed:

Name
The name of the scheme. Note that this is the name that you give the scheme when you install it.

Updated
Date that the scheme was last modified

Alert
The Alert field is used to show that an error has occurred that needs attention. For a scheme in this list, an alert means that the business entity has been changed (in Navision), so that business entity fields have either been removed or modified. (Note that adding fields does not pose a problem.)

When a scheme in the list is flagged with an alert, you can click File, View Log to open the log file and get more information.

Completed schemes

The schemes in this list are ready for use. They can be started, stopped or copied to Schemes for construction.

To start a scheme in the list , you select it and then click Start. After a scheme has been started, it becomes available for subscription, and notifications will be sent.

To stop a scheme, you select it and then click Stop. When a scheme is stopped, new subscriptions are not accepted and notifications are not sent.

To copy a scheme to the Schemes for construction list, you select and click Copy for construction.

When a scheme that has previously been completed is copied to the Schemes for construction list and then modified, you can move it back to the Completed schemes list just like a brand new scheme. In this situation, there are two different possibilities:

  1. As part of the modification, you give the scheme a new name. You can move it to the Completed schemes list just like any new scheme.

  2. As part of the modification, you do not change the name of the scheme. If you move it back to the Completed schemes list it will overwrite the "old scheme". A confirmation dialog box will appear before the move is completed.

For each scheme in the list, the following information is displayed:

Name
The name of the scheme. Note that this is the name that you give the scheme when you install it.

Updated
The date that the scheme was last modified.

Status
The status of the scheme. There are three options:

  • Started- the scheme is active.

  • Stopped - the scheme is inactive.

  • Being Started - the scheme is in the process of being started, but the process is not yet complete. (The status automatically changes to Started if this process completes successfully.)

  • Being Stopped - the scheme is in the process of being stopped, but the process is not yet complete. (The status automatically changes to Stopped if this process completes successfully.)

Alert
The Alert field is used to show that an error has occurred that needs attention. For a scheme in this list, two errors can occur:

  • An attempt was made to start the scheme, but the scheme could not be started, due to some technical error (lack of communication with the deployment server, for example) or because the scheme has some internal formatting error.

  • The business entity has been changed (in Navision), so that business entity fields have been either removed or modified, or the event has been removed. (Note that adding fields does not pose a problem.)

When a scheme in the list is flagged with an alert in the list, you can click File, View Log to open the log file and get more information.

Menu Items

The following is a description of the menu items in the drop-down menu under File:

  • New - To create a new scheme, click File, New. The Business Notification Designer will open with a new, empty scheme. When the scheme is saved in the Business Notification Designer it will appear in the Schemes for construction list.

  • New from template - To see a list of installed templates, click File, New from template. When you click on one of these templates, a copy of the corresponding scheme will open in the Business Notification Designer (with a default name of "New from <template name>").

  • Open - To open a scheme in the Schemes for construction list, select the scheme and then click File, Open.

  • New from Existing - To create a new scheme based on a scheme that is already installed, select the scheme you want to use as the basis for a new scheme (it can be in either the Schemes for construction list or in the Completed schemes list) and click, File, New from Existing. A copy of the selected scheme will open in the Business Notification Designer (with a default name of "New from <scheme name>”).

  • View Log - To view the log file for a scheme, select the scheme and then click File, View Log. A window will appear that shows the current log for the scheme. The log contains entries for all actions on the scheme since it was first created. This includes: when it was created, modified, published and unpublished, as well as any alerts (for example, when publishing a scheme failed; or when the XMLport was modified in Navision.)

  • Delete - To delete a scheme, select the scheme and click File, Delete.

  • Exit - To exit the Business Notification Manager, click File, Exit.

The following is a description of the menu items in the drop-down menu under Tools:

  • Import - To import a scheme from a file in the file system, click Tools, Import. Select the file in the standard Windows file dialog that appears.

  • Export - To export a scheme to a file, click Tools, Export. Select a folder and enter a name in the standard Windows file dialog that appears.

  • Connect to server - To select a server to connect to, click Tools,Connect to server. After this had been done once, the Business Notification Manager will automatically connect to this server when it is started (until another server is selected).

  • Security - To open the User Administration form, click Tools, Security. In this form, you can add Windows users and thereby give them permission to use the Notification Manager and Notification Designer. You should be aware that, by granting users permissions in Business Notification, you also allow them to be able to distribute information from Navision that might be restricted. Therefore, you must be careful not to provide a "back door" into sensitive Navision data this way.

  • Template administration - To open the Template Administration tool click Tools,Template administration.

The following is a description of the menu items in the drop-down menu under Help:

  • Business Notification Guide - To open the Business Notification Guide (the help file you are reading), click Help, Business Notification Guide.

  • About - To see information about the Microsoft Business Solutions – Navision Business Notification (version, copyright information, and so on) click Help, About.

Buttons

The following buttons are on the main form:

  • New - To create a new scheme, click New.

  • New from template - To create a new scheme based on a template, click New from template.

  • Copy for construction - To copy the currently selected scheme from the completed list to the construction list, click Copy for construction.

  • Complete - To move a scheme from the Schemes for construction list to the Completed schemes list, click Complete.

  • Start - To start a scheme, that is, to make it active and enable users to receive notification messages and to allow new users to subscribe, click Start.

  • Stop - To stop a scheme and temporarily withhold notifications and new subscriptions, click Stop. This is also the first step you have to take before you can modify a scheme (the second step is to move the stopped scheme to the Schemes for construction list).

  • Introduction - To go directly to the "Getting started" topic in this help file, click Introduction.

Shortcut Menus

In both lists of schemes – the Schemes for construction list and the Completed schemes list – a shortcut menu is available for the most common tasks. To access the shortcut menu, right-click a scheme in the list.

Shortcut menu in the Schemes for construction list:

  • Open
    Open the scheme for modification

  • New from existing Scheme
    Create a new scheme by copying the selected scheme

  • Delete
    Delete the selected scheme

  • View History
    View the history for the selected scheme

  • Export
    Export the selected scheme to a file

Shortcut menu in the Completed schemes list:

  • Open
    Open the selected scheme for viewing (read-only)

  • New from existing Scheme
    Create a new scheme by copying the selected scheme

  • Delete
    Delete the selected scheme

  • View History
    View the log for the selected scheme

  • Export
    Export the selected scheme to a file


Notification Manager Template Administration

The Template Administration form is used for working with templates. In this window, you can import templates from the file system and you can delete previously installed templates. To access the Template Administration form, from the Notification Manager main form, click Tools, Template Administration.

To import a template:

The template must be located where you can access it from your computer (in a local folder, on a network server, or similar.)

  1. Open the Template Administration tool by clicking Tools, Template Administration.

  2. Click Add.

  3. Select the file that contains the template in the standard Windows folder browse dialog, and then click Open.

The template is imported, and is displayed in the list of Existing/Installed templates.

Note that if the selected file is not a valid template file, it will not be imported, and an error message will be shown instead. If the name of template (inside the file - not the name of the file itself) clashes with an existing template, the developer of the template will have to change it. This is not something you can from the Notification Manager.

To delete a template:

  1. Open the Template Administration tool by clicking Tools, Template Administration.

  2. Select the template you want to delete.

  3. Click Delete.

  4. A confirmation dialog box will appear. Click Yes to confirm that you want to delete the template.

The template is removed from the list of Existing/Installed templates.


Incompatible Business Entity

A business entity can become "incompatible" for various reasons. The general meaning is that the business entity (XMLport) in Navision is no longer the same as when it was used to design a scheme in Business Notification.

The three specific reasons for incompatibility are:

  1. The business entity exists in the same way as when the scheme was created, but the fields are no longer the same. This means that fields have been deleted from or renamed in the underlying XMLport in Navision. (Note that adding a field does not pose a problem.) The following alert appears: "Incompatible with business entity fields in Navision."

  2. The event that was used for the scheme has been deleted from or renamed in the business entity in Navision. The following alert appears: "Incompatible; selected event is not available in Navision.”

  3. The business entity itself has been deleted from or renamed in Navision. The following alert appears: "Incompatible; selected business entity is not available in Navision."

In any of these cases there is no way to correct the problem in Business Notification. The underlying problem in Navision must be solved.


View History

View History shows a history "log" of a scheme in the Notification Manager. The information displayed includes:

  • An activity (such as "Created", "Completed")

  • The time when the activity took place

  • The user that performed the activity

  • The source of the activity - either Completed or Configuration (this distinction is necessary because a scheme that has been completed can be copied back to construction, carrying the same name in both places)

  • Details: for some activities, especially when an error occurs, there will be some information in this field

The list can be sorted on a column by clicking on the column label.


Notification Designer Overview

The Notification Designer is used for creating and modifying schemes. It is started from the Notification Manager. If you want to create a new scheme, click File, New. If you want to modify an existing scheme, select the scheme in the Schemes for construction list and then click File, Open. (There are also alternative methods to do this, which you can read about in the Notification Manager topic.)

On the first form you see, the main form, you must give the scheme a name. If the new scheme was not created from scratch, but from a template or by copying an existing scheme, a default name will already have been proposed. You can change this default name to fit your needs.

At the bottom of the main form there is four buttons:

Validate: Click Validate to test that the scheme is valid, that is, that the Business Notification system is able to understand and use the scheme.
OK: Click OK to save and exit the Notification Designer.
Cancel: Click Cancel to exit the Notification Designer without saving.
Help: Click Help to open the online help for the form.

There are four forms that you can access from the main form of the Notification Designer:

Event: the event selection form where you select the (Navision) event that will start this scheme when the event occurs. You cannot enter any of the Filter, Message or Recipients forms before you have selected an event.

Filter: the form where you can decide if an event received from Navision should cause a notification to be sent, based on the concrete data in the event document coming from Navision.

Message: the form where you can create the e-mail message that is sent to subscribers when they are notified. You can merge data into the message from documents received from Navision.

Recipients: this form is used to give internal users permissions to subscribe to notifications; to create the "interface" that internal users see when they subscribe; and also to explicitly add external recipients (who cannot use the Intranet-based subscription tool) as subscribers of a notification.


The Event Selection Form

This form is used to select an event from Navision. Two concepts are important here:

  • Business entity: a business entity is a representation of one or more Navision "objects" that correspond more closely to objects in the "real world" - hence the name "business entity". While a "sales order" in Navision is composed from two tables (a table with the header, and a table with the lines) a "sales order business entity" would contain data from both the header table and the lines table. Read more about how this is done in Navision here.

  • Event: for each business entity in Navision, one or more events are connected. An event is a meaningful name for "something" that happens in the Navision business logic that causes a document, containing the data of a business entity, to be sent to Business Notification. For a sales order, an event could be "Order amount greater than 10,000," and when a sales order is created in Navision with an amount greater than 10,000, this event happens ("is raised"). The same sales order could have other events, for example, "Customer credit limit exceeded."

To select an event:

  1. Select a business entity. Once you have done that, the lists of events is updated to show the events for the selected business entity.

  2. Select an event from the list of events for the selected business entity.

  3. Click OK.

When you have selected a business entity, you can click View fields in business entity to show a (read-only) list of the data fields in the business entity. This can help you decide if you have selected the correct business entity. Later on, these are also the fields that can be merged into the notification message that is automatically sent to subscribers when the event is raised by Navision.

Warning

If you are modifying an existing scheme, all settings (filters, messages, and so on) will be reset to the default value if you change the business entity and/or event. When you are modifying an existing scheme, you will probably always want to review the information in this form, and then click OK without changing anything. If you change something, you will receive a warning before you proceed.


Field View

This form shows you the fields that are available in the business entity. This is to help you decide if this is the correct business entity for the notification you are creating. For example, these are the fields that will be available for merging into notification messages and these are the fields you can use in filters.


The Filter Form

When you have selected an event, you can use a filter to determine in more detail if the event should cause notifications to be sent when it is raised.

For example, if have you selected the "Order amount greater than 10,000" event for a "Sales order" business entity, Business Notification will receive a document from Navision each time this event occurs. However, you could also decide that, in addition to the decision already made inside Navision about the order amount, in your company you only want to have notifications sent to subscribers if the sales order is for a customer in Denmark. You can use a filter on the country code to ensure this.

Each set of drop-down lists and text boxes that you see on the Filter form represents a filter on one data field in the document received from Navision. More lines, with additional filter settings, can be added by clicking Add. An existing line can be removed by clicking Delete.

The following describes the elements of each line in the Filter form.

Business entity fields: A list of fields from the business entity. For example: "Country Code."

Operator: How the parameter (business entity field) should be compared to the value. The options that are available depend upon the type (Date/Time, Text, Number or Boolean) of the parameter:

  • Date/Time fields, such as the Order Date field, can have the following operators: Equal To; Equal To or After; Equal To or Before; Before; After.

  • Text fields, such as the Vendor Name field, can have the following operator: Is exactly.

  • Number fields, such as the Amount field, can have the following operators: Equals; Not Equal To; Equals or More Than; Equals or Less Than; More Than; Less Than.

  • Boolean fields are fields that can only have two values: Yes or No. They can have the following operators: Is; Is Not.

Value: The actual value from Navision that the parameter should be compared against. For example:

The event is "Sales order amount above 10,000", but you are only interested in sending notifications if the customer in this case is in the United States.

  1. Select "Country Code" as the parameter. Because this a text value, you can choose between the operators that are applicable for text fields.

  2. You want an exact match for a specific country code, so select "Is exactly" as the operator.

  3. Finally, enter "U.S." as the value, because you want to only send notifications for customers in the United States.

Note: you cannot look up the value in the Navision database from the Notification Designer. You may want to check the possible values in Navision if you are in doubt about spelling and so on (by using the regular Navision client interface).

Relation: The relation is only relevant if you add lines to the filter. You add a line by clicking Add. The relation determines how the settings on each line should be combined. There are two possible values:

  • AND: Settings on lines connected by an AND relation should all be met at the same time.

For example, if you want to create a filter that sends notifications only when the "Country Code" parameter is "U.S." and the "Location Code" is 1, you create these two lines as described above and join them with an AND relation.

  • OR: Either one of the settings on lines connected by an OR relation should be met.

For example, if you want to create a filter that sends notifications only when the "Country Code" is "U.K." or when the "Country Code" is "DK" you create these two lines as described above and join them with an OR relation.

Some advice about logical operators

What happens if you have more than 2 lines and want to join them with relations?

If you want to use the same relation to join all lines, there is no problem. Using only the AND relation, you could express that "Country Code" must be "U.S.", and "Location Code" must be "1", and "Status" must be "Open", and "Project Code" must be "Blue" all at the same time.

A series of AND relations are most often (but not exclusively) used when you want to filter on a set of different fields.

If you want to express that "Country Code" could be either "U.S.", "DK" or "U.K.", you would use the OR relation to join such three lines.

A series of OR relations are most often (and almost exclusively) used to pick certain values out of the set of possible values for the same field.

The problem arises when you want to combine AND and OR. The concise description of what happens is that AND has precedence over OR, and that the relations are evaluated from left-to-right (which, in the way that the form is laid out, is from up-to-down). Using a mixed set of relations can be confusing but can often be avoided be creating more than one scheme. For more information about interpreting a combination of AND and OR relations click here.


More About Filters

The following example explains more about interpreting a combination of AND and OR relations.

For example, you have this filter:

CountryCode = "DK" AND LocationCode = "1" OR Status = "Open"

Given a business entity where the fields in question have these values:

CountryCode = "CA"
LocationCode = "2"
Status = "Open"

the filter evaluates as True - meaning that this business entity would be selected by the filter. But was that the intention? The intention might really have been to express this:

CountryCode = "DK" AND (LocationCode = "1" OR Status = "Open")

or, in more accessible terms: select the business entity if the country code is "DK" and, either the location code is "1" or the Status is "Open."

Because there is no way to put the parentheses in, it is not possible to express the second version in Business Notification.

The solution is to create two schemes:

  1. A scheme with a filter like this: CountryCode = “DK” AND LocationCode = “1”.

  2. And a scheme with a filter like this: CountryCode = “DK” AND Status = “Open”.

In the example above, by creating two schemes, the business entity would not be selected by any of these filters (and this was the intention.) Of course, users will have to subscribe to both schemes in order to get the notifications as intended.


The Message Form

The message form is used for creating the notification e-mail messages for a scheme.

On the top of the form, in the From field, you must enter a valid e-mail address. If somebody replies to a notification e-mail, the replies will be sent to this address.

On the left side of the form are the Subject field and the Contents field.

In the Subject field, you define the subject of the e-mail message. In the Contents field, you define the body of the e-mail message.

On the right side of the form is a list of all the fields received from Navision. You can insert a field in either the subject or the body of the e-mail message by placing the cursor where you want to insert the field, selecting the field, and clicking Insert field. The field will be inserted in the position where the cursor was when you selected the field.

The list of fields is organized as a tree, similar to how the Windows Explorer shows folders and files. There are three different kinds of items in the list: fields, repeating groups and groups. These are described below, along with the icons used for each type:

The icon [image] represents a field. This is a field as received from Navision, for example "Order No." When you have inserted a field, you can write text around it, move it around, and so on. For example:

You can insert fields into the body of an e-mail message like this:

Dear [Buy_from_contact]

And when real data starts arriving from Navision, the program will insert text such as:

Dear Mrs. Alana Lemlin

Dear Mr. James Day

The icon [image] represents a repeating group. A repeating group is a group of fields that can occur a number of times (or not at all). The group is marked as such when it is inserted. For example:

On a sales order, there can be a repeating group called, for example, "Sales Order Lines." When this group is inserted into an e-mail message (and it is probably only relevant to put it in the body of the message) it means that the fields in the group are repeated for as many times as there is actual data in the document received from Navision.

The icon [image] represents a group. A group is a "heading" that is used to place some fields together. For example:

For a sales order, all fields that are related to payments could be in a group called "Sales Order Payments." If a group is inserted, all fields in this group (and any subgroups of this group) are inserted into the e-mail message. It is not recommended to add a group to the subject of a message.

About localizing messages:

If you want to send messages to, for example, business partners in different countries in their native languages, what you must do is create a scheme for each language, and then use filters to make sure the "right" scheme is used to send the message.


The Recipients Form

The Recipients form is used for three tasks:

  • Giving internal users permissions to subscribe to notifications

  • Creating a description that an internal user will see when they use the browser-based subscription application

  • Adding external recipients (like business partners)

Each task has its own tab on the form.

The Internal Recipients Tab

In order for a user to be able to use the browser-based subscription interface to sign up for notifications, you must give them explicit permission to do so.

The upper part of this tab, "Sign-up permission", is used for this.

You add a user by clicking Add. This opens the standard Windows form for selecting users from the Active Directory. This is the same form you see when you click Control Panel, User Accounts, Add, Browse.

The easiest way to find a user is to type the full name (for example "John Smith") in the Enter the object name to select text box, and then click Check Names. Verify that you have found the correct user, and click OK. The user will be added to the list of users that are allowed to sign-up. You can add individual users as well as groups.

To delete a user (revoke the permission to sign-up), select the user in the list of users, and then click Remove.

Below, in the area called "Sign-up information", you enter the title and the description of the notification that a user sees in the browser when they select notifications to subscribe to.

The title is not the same as the name you give the scheme in the Notification Designer (this is also the name you see in the Notification Manager). Neither is it the same as the name that a template has. The relationships between these different names are explained in the following example:

It is recommended that you construct the name of a template as follows: <business entity name> - <event name>. For example: "Sales Order - Credit Limit Exceeded."

Based on this template, you can create a number of schemes. For example, you can create one scheme that can send notifications when the customer is in the U.S. and one that can send notifications when the customer is in Canada. You could name these two schemes "Sales Order - Credit Limit Exceeded (U.S.)" and "Sales Order - Credit Limit Exceeded (Canada)." Remember that these names are only visible in the Notification Manager and Designer.

Finally, for the users who are going to be able subscribe to these two schemes, you must create a title and a description, for example:

Title: U.S. Customer Credit Limit Exceeded

Description: This notification alerts you when a sales order for a U.S. customer is created and the credit limit for that customer is exceeded.

(And a similar one for the Canadian example.)

The point here is that the title and the description can be a lot more user-friendly and helpful than the names in the Notification Manager and Designer.

The External Recipients Tab

If you want to let an external recipient (such as a business partner) subscribe to a notification, you have to do it explicitly in this form. This is because external recipients are not, normally, registered as Windows users in your company, so they cannot be given permissions to subscribe themselves. Also, the subscription application is intended to run on the Intranet, so they cannot use it anyway.

To add an external recipient:

  1. Insert a check mark in the "Send message to external recipients" checkbox to allow external recipients to subscribe.

  2. Place the cursor in the Recipients: text box, select a field from the list of fields, and click Insert field. The field should be an e-mail address, such as "Vendor e-mail."

  3. You can also enter "hard-coded" addresses directly in the Recipients: text box.

  4. In either case, multiple addresses must be separated by semi-colons.

The actual e-mail message sent to external recipients will be the same as the one used for internal subscribers. If you want to create a different message for an external recipient, you must create a separate scheme for this purpose. If you have already created a scheme for internal subscribers, you can copy this scheme, and edit the message.


Administration

After Business Notification has been installed, you must pay attention to:

Password Change
If the password of the user account that Business Notification is running under is changed, you must perform the procedures described in this topic. If not, Business Notification will stop working.

Backup
As part of your normal backup routine, you should take a backup of Business Notification. This topic describes what needs to be backed up.

Configuration Files
You might need to change some values in a configuration file after you have installed and have started using Business Notification. If the SMTP server you use for sending e-mail messages changes, it is absolutely necessary to inform Business Notification of this. You may also want to change the logging


Password Change

Password Changed

During installation of the Business Notification Server, you have to enter the name and password of a Windows user (domain user). This user is used for the following purposes:

  • The Business Notification server-side applications and services are running under this user account.

  • This user account is used for logging on to the SQL Server.

If, or when, the password is changed - maybe because your company has a policy of enforcing password changes at set intervals - you have to perform the following procedure in order to ensure that the new password is used by the Business Notification applications and services:

  • On the computer that runs the Business Notification Server components, locate the folder where these components are installed (the default is "Program Files\MicrosoftBusinessSolutions\Navision\BusinessNotification\InstallUtility." There is a small utility in this folder, called "aspnet_setreg.exe."

  • Open the Command Prompt window in this folder.

  • At the command prompt type:
    "aspnet_setreg.exe -k:SOFTWARE\Microsoft\BusinessSolutions\BN\identity -u:domain\username -p:password"
    where you replace "domain\username" and "password" with the domain and username of the account in question and the new password.

This will reset the cached password that the server components are using with the new one.

More information is available here.

Furthermore, you have to manually set the new password for two services on the computer that is running the Business Notification Server components:

  • Open the Services application (click Control Panel, Administrative Tools, Services, or the equivalent command - the location in the menus vary from one operation system to another).

  • Locate the service called "Notification Service Deployment Manager."

  • Right-click the name, and then click Properties.

  • Click the Log On tab and change the password.

  • Locate the service called "NS$BusinessNotificationInstance."

  • Right-click the name, and then click Properties.

  • Click the Log On tab and change the password.


Backup

You should take backups of the data storage that Business Notification uses regularly (or work these into your existing backup schedule). The things that will need to be backed up are:

  • The SQL Server databases. Their names are:
    BusinessNotification
    BusinessNotificationInstanceMBSBN

  • BusinessNotificationInstanceNSMain
    On the machine where the Business Notification Server is running, the following file should be backed up: appADF.xml
    If you installed the Business Notification Server to the default location then this file is located in the following folder:
    \ProgramFiles\MicrosoftBusinessSolutions\Navision\BusinessNotification\BusinessNotificationServices\AppDefinition


Configuration Files

In the file called Web.config there are two settings that you may need to change. You can find the file on the computer where the Business Notification Server is installed, in the folder \ProgramFiles\MicrosoftBusinessSolutions\Navision\BusinessNotification\DeploymentServer (if you installed in the default location; otherwise in the equivalent folder on your system).

If you change your SMTP server after installation, you must:

In the <appSettings> section, change "localhost" to the name of your (new) SMTP server:

<add key="SmtpServer" value="localhost"/>

(Note: If you used another name than "localhost" for the SMTP server during installation, this name will be the "value" instead of "localhost.")

You might want to change the logging level. To do this:

In the <appSettings> section, change the "value" in the following:

<add key="applicationLogLevel" value="debug"/>

to one of the following:

  • debug: means that everything is logged

  • error: means that only errors are logged

  • none: means no logging at all

Unless you have very specific reasons, for example that the log gets very large, use "debug."


Changing Time On The SQLNS Server

It is of the utmost importance that you do not change the system time backwards in time on the computer that is running the Microsoft SQL Server Notification Services manually. If you do, Microsoft SQL Server Notification Services can crash, and this will result in data loss (loss of notifications.)

Therefore, you should set this computer up to automatically adjust for daylight savings time. Follow this procedure:

  1. Open Control Panel, Date and Time.

  2. Click the Time Zone tab.

  3. Check that "Automatically adjust clock for daylight savings changes" is selected.

Setting the time forwards does not provoke a crash in the same way, but will cause notification messages not to be sent.


Overview of Events

This topic describes how to raise events from the Navision business logic and it outlines some of the background and terminology used.

Business entity: the name used by Business Notification for the representation of a "real-world" object, such as a sales order.

In Navision, however, a business entity, such as the sales order, is typically represented as a number of tables, at least a header table and a lines table. Furthermore, some of the data that would be on a traditional, paper-based sales order, is stored in related tables: For example, in a Navision sales order, the header table contains a Payment Terms Code. This field has a table relation to the Payment Terms (in relational database terms it is a foreign key). Yet on the printed order confirmation (a report) the text from the related table is used in order to print a more readable version of the payment terms ("1 Month/2% 8 days" instead of "1M(8D)".)

So, in a way, a Navision report is already, in some ways, a "business entity." The business entities relevant for Business Notification are, however, created as XMLports in Navision.

XMLports are a new feature in Navision 4.0. In short, they provide a way to produce an XML document from one or more tables, somewhat equivalent to what you can do when designing a report. The Navision documentation contains all the details about how to design an XMLport in general.

For the purpose of Business Notification, an extension has been made to XMLports that allows such an XML document to be transmitted to Business Notification from C/AL code.

The mechanism used for this is the event. An event serves two purposes:

  • Firstly, in Navision, when a event has been defined for an XMLport, it can be called just like a function. But an event does not have a function body: when it is called, the XML document that the XMLport the event "belongs to" is sent to Business Notification.

  • Secondly, in the Business Notification designer, events serve to communicate between the C/AL developer and the Business Notification scheme developer. Choosing good names for events, that clearly communicate the circumstances under which the event is raised in the C/AL code makes it a lot easier for the scheme developer to decide how to handle the event, what filters to set, what internal users should have permission to subscribe, what title and description to give the scheme to support internal users when they use the subscription application, and what external recipients it would be relevant to send the notification message to.


Creating Events in Navision

The following is a very simple example of how to raise events from the Navision business logic. Navision simply detects a condition, and raises an event immediately.

  1. State and analyze your business problem. The example followed here is: notify when a customer is blocked (when the Blocked status changes from False to True).

  2. Decide what data should be in the XMLport. For example, the ID and Name of the customer; the date when the change happened; and the salesperson code. The salesperson code can then be used for filtering in Business Notification so that each salesperson can get notifications about their own customers.

  3. Create an XMLport that contains the data you need. "The Application Designer’s Guide" and the C/SIDE online Help provide the information you need. In this example, it could be called "Customer" (although you may want to establish some naming convention. For example, you may want to call it something like "Customer Notification.") Remember that this is the name that will be seen as the "business entity" in the Notification Designer.
    Note:     TagNames should not contain spaces and the Format/Evaluate property of the XMLport must be set to "XML Format/Evaluate" (this is not the default, so you do have to change it yourself.)

  4. Add an event to the XMLport by using the Events Designer (accessed from View menu, under the XMLports Events option). In this example, it could be called "HasBeenBlocked." This name is also visible in the Notification Designer.

Now you have to find where to raise the event in the business logic. In this example, this would be in the OnModify trigger in the Customer table (obviously, we will then not catch the case where a customer is created and Blocked is set to True from the beginning - but that was not the purpose, either. The purpose was to catch situations where a customer that was previously unblocked is being blocked.)

  5. To raise the event in the business logic, you must declare the XMLport you have created as a local variable. It could, for example, be called "CustXMLDoc" (this name is not visible in the Notification Designer).

  6. Next, add the following to the OnModify trigger:
    IF Blocked = Blocked::All THEN
    IF Blocked <> xRec.Blocked THEN
    CustomerXMLDoc.HasBeenBlocked();

  7. Now you can use the Notification Designer to create a scheme that handles this event which will be available as the "HasBeenBlocked" event for the "Customer" business entity.

Testing

This example is obviously very simple. Most solutions will, however, be much more complex. This raises the issue of how to test the solution and find errors. If nobody is receiving notifications and you think that they should be, there are at least three places to look for mistakes: (1) in the Navision business logic, (2) in the scheme in Business Notification, or (3) in the infrastructure setup such as problems with mail servers and so on. It could also be due to a genuine bug in either of the components in the system. In order to see if Navision actually raises the event when you think it should, you could replace

CustXMLDoc.Blocked();

with, for example:

DIALOG.MESSAGE('%1 blocked', Name);

Then you will get a confirmation dialog when the event should be raised and you can test if it is, indeed, raised when it should be. This approach is obviously best suited when events are raised "interactively" and not when run as a batch job. Still, in the second case, you may be able to adopt a similar approach.


Time-based Events

A simple example of an event is that it is raised when a record is modified in Navision. There is, however, especially in ERP systems, a large number of situations where what is called for is a "time-based" event. An example of a time-based event is:

Go through all purchase orders, and send a reminder to the vendor if there is less than six days to the promised receipt date.

Because there is no "timer" in Navision that can be used for this, the way to solve this problem is to create a report, or something similar, that performs this processing, and then run this report at fixed times. This, of course, means that there is an element of manual processing involved, namely running the report, but there are still great gains from using Business Notification in an example such as this. The alternative, fully manual, solution would be to go through such a report manually, and contact each vendor. This would be time-consuming, and also more prone to oversights.

When developing such a solution, there are some things that you need to be aware of. The most important is that you will need to keep track of who has already received a notification. In this example, you would need to track the vendors who have already received a notification, to avoid sending them inappropriate e-mail messages.

Some of the templates that are delivered with Business Notification are time based. If you want to develop something similar you can look at these solutions for inspiration. You can also use the framework that has been used for these solutions. There is also some documentation available in the partner guide for Business Notification.


How to Subscribe

Internal users need to subscribe in order to receive notifications. In order for you to be able to subscribe, either you, or a group that the you are a member of, must have permission to subscribe.

The subscription is made through a Web browser. The URL to use is "http://<servername>/BusinessNotificationSubscribe", where <servername> is the name of the server where the Business Notification server component is installed.

The first page you see is the My Notification Subscriptions page This page contains a list of existing subscriptions (if any). You can check to see the e-mail address your notifications are sent to by clicking My Information. This is the e-mail address that is registered for you in Windows.

To add a new subscription:

  1. On the My Notification Subscriptions page, Click Add New.

  2. On the Select new Notification Subscription page that appears, click the option button to select the notification that you want to subscribe to. Then click Add Selected. Note that you can only select one notification at a time.

You are automatically returned to the subscription list and can see the notification you just added in the list.

To delete an existing subscription:

  1. On the My Notification Subscriptions page, insert a check mark to select one or more subscriptions in the list.

  2. Click Delete Selected.

  3. A confirmation dialog box will appear. Click Yes to confirm that you want to delete the selected subscriptions.


Template Description

A number of templates come with Business Notification. In order to use them you must:

  1. Use Notification Manager Template Administration to bring the template into Business Notification.

  2. In the Notification Manager, click New from template to create an editable copy of a template you want to use.

Most, but not all, of these templates are time based. This means that events are not raised immediately in Navision. For any time-based template, some additional setup is required in Navision. The Business Notification Help topic in Navision explains how to raise these events. Two of the templates are not time based, and the events are raised immediately.

However, in order for any event to be raised in Navision from these templates, time based or not time based, you must click Administration, IT Administration, General Setup, Business Notification Setup and then insert a checkmark in the Send Notifications field.

Below is a short description of the six templates.

Business entity

Event

Description

Item

Inventory Status

This template is used to send a notification about item quantities on stock, as well as ordered quantities, to suppliers.

The idea is that suppliers can use this information to decide when they need to replenish stock.

This template is time based. The Navision Help topic called Business Notification, Notifying Suppliers About Inventory Status explains how to use it.

Production Order

Production Order Delayed

This template is used to inform an account manager when a production is delayed. The account manager can then use this information to proactively inform customers about delays in delivery.

This template is time based. The Navision Help topic called Business Notification, Notifying the Production Department About Delayed Production Orders explains how to use it.

Product. BOM

Production BOM Changed

This template is used to inform recipients about changes to a BOM (bill of materials).

The event is raised immediately when the status of the BOM is changed to either Certified or Closed.

Product. BOM ver.

Production BOM Changed

This template is used to inform recipients about changes to a BOM (bill of materials) version.

The event is raised immediately when the status of the BOM version is changed to either Certified or Closed.

Purchase Order

Notify About Upcoming Delivery

This template is used to remind suppliers about upcoming deliveries. The supplier receives a notification a number of days before the promised delivery date.

The notification can be sent to selected suppliers only, and for selected items.

This template is time based. The Navision Help topic called Business Notification, Notifying Suppliers About Upcoming Deliveries explains how to use it.

Purchase Order

Unconfirmed Purchase Order

This template is used to inform a purchaser about missing order confirmations, that is: order confirmations that have not been received within a (configurable) time limit after a purchase order has been published.

This template is time based. The Navision Help topic called Business Notification, Notifying Purchase Managers About Unconfirmed Purchase Orders explains how to use it.

Purchase Order

Items Not Received

This template is used to check if suppliers deliver in due time, and to warn if items are not delivered despite supplier confirmation.

This template is time based. The Navision Help topic called Business Notification, Notifying Purchase Managers About Items Not Received After the Promised Receipt Date explains how to use it.